#include "std.h"
#include "Malical.h"

Array* array_new ()
{
	Array * array;
	array = (Array*)malloc(sizeof(Array));
	array->begin = NULL;
	array->end   = NULL;
	array->size  = 0;
	return array;
}

Element * array_push_back (Array *a,Object *o)
{
	if (a->size==0)
	{
		a->begin = (Element*)malloc(sizeof(Element));
		a->begin->next = NULL;
		obj_ini(&a->begin->obj);
		obj_copy(&a->begin->obj,o);
		a->end = a->begin;
		a->size ++;
	}
	else
	{
		a->end->next = (Element*)malloc(sizeof(Element));
		a->end = a->end->next;
		a->end->next = NULL;
		obj_ini(&a->end->obj);
		obj_copy(&a->end->obj,o);
		a->size ++;
	}
	return a->end;
}

void array_delete (Array *a,int i)
{
	if (a->size <= 0)
		return;
	else if (i > a->size-1)
		return;
	else if (i < 0)
		return;
	else
	{
		if (i!=0)
		{
			int j;
			Element *e,*p = NULL;
			e = a->begin;
			for (j=0;j<i;++j)
			{
				p = e;
				e = e->next;
			}
			if (p)
			{
				p->next = e->next;
				free(e);
				a->size --;
			}
		}
		else
		{
			Element *e = a->begin->next;
			free(a->begin);
			a->begin = e;
			a->size --;
		}
	}
}
Element *array_element (Array *a,int i)
{
	if (a->size <= 0)
		return NULL;
	else if (i > a->size-1)
		return NULL;
	else if (i < 0)
		return NULL;
	else
	{
		int j;
		Element *e;
		e = a->begin;
		for (j=0;j<i;++j)
		{
			e = e->next;
		}
		return e;
	}
}

void array_destory (Array *a)
{
	Element *e,*p;
	e = a->begin;
	while (e!=NULL)
	{
		p = e;
		e = e->next;
		if (p->obj.tag==VT_ARR)
			array_destory ((Array*)p->obj.value.ref);
		obj_clear(&p->obj);
		free(p);
	}
	a->size = 0;
	a->begin = a->end = NULL;
}

Array* array_create_by_stack (ObjectStack *stk)
{
	int i;
	Array *a = array_new();
	for (i=0;i<stk->size;++i);
	{
		array_push_back(a,&stk->stk[i]);
	}
	return a;
}