
#include "fxlib.h"

unsigned char convertKeycode(int keycode)
{
	unsigned char keycodebasic;
	switch (keycode)
	{

		case KEY_CHAR_0: keycodebasic = 71; break;
		case KEY_CHAR_1: keycodebasic = 72; break;
		case KEY_CHAR_2: keycodebasic = 62; break;
		case KEY_CHAR_3: keycodebasic = 52; break;
		case KEY_CHAR_4: keycodebasic = 73; break;
		case KEY_CHAR_5: keycodebasic = 63; break;
		case KEY_CHAR_6: keycodebasic = 53; break;
		case KEY_CHAR_7: keycodebasic = 74; break;
		case KEY_CHAR_8: keycodebasic = 64; break;
		case KEY_CHAR_9: keycodebasic = 54; break;
		case KEY_CHAR_DP: keycodebasic = 61; break;
		case KEY_CHAR_EXP: keycodebasic = 51; break;
		case KEY_CHAR_PMINUS: keycodebasic = 41; break;
		case KEY_CHAR_PLUS: keycodebasic = 42; break;
		case KEY_CHAR_MINUS: keycodebasic = 32; break;
		case KEY_CHAR_MULT: keycodebasic = 43; break;
		case KEY_CHAR_DIV: keycodebasic = 33; break;
		case KEY_CHAR_FRAC: keycodebasic = 75; break;
		case KEY_CHAR_LPAR: keycodebasic = 55; break;
		case KEY_CHAR_RPAR: keycodebasic = 45; break;
		case KEY_CHAR_COMMA: keycodebasic = 35; break;
		case KEY_CHAR_STORE: keycodebasic = 25; break;
		case KEY_CHAR_LOG: keycodebasic = 66; break;
		case KEY_CHAR_LN: keycodebasic = 56; break;
		case KEY_CHAR_SIN: keycodebasic = 46; break;
		case KEY_CHAR_COS: keycodebasic = 36; break;
		case KEY_CHAR_TAN: keycodebasic = 26; break;
		case KEY_CHAR_SQUARE: keycodebasic = 67; break;
		case KEY_CHAR_POW: keycodebasic = 57; break;
		case KEY_CTRL_EXE: keycodebasic = 31; break;
		case KEY_CTRL_DEL: keycodebasic = 44; break;
		case KEY_CTRL_AC: keycodebasic = 10; break;
		case KEY_CTRL_FD: keycodebasic = 65; break;
		case KEY_CTRL_XTT: keycodebasic = 76;break;
		case KEY_CTRL_EXIT: keycodebasic = 47; break;
		case KEY_CTRL_SHIFT: keycodebasic = 78; break;
		case KEY_CTRL_ALPHA: keycodebasic = 77; break;
		case KEY_CTRL_OPTN: keycodebasic = 68; break;
		case KEY_CTRL_VARS: keycodebasic = 58; break;
		case KEY_CTRL_UP: keycodebasic = 28; break;
		case KEY_CTRL_DOWN: keycodebasic =37; break;
		case KEY_CTRL_LEFT: keycodebasic = 38; break;
		case KEY_CTRL_RIGHT: keycodebasic = 27; break;
		case KEY_CTRL_F1: keycodebasic = 79; break;
		case KEY_CTRL_F2: keycodebasic = 69; break;
		case KEY_CTRL_F3: keycodebasic = 59; break;
		case KEY_CTRL_F4: keycodebasic = 49; break;
		case KEY_CTRL_F5: keycodebasic = 39; break;
		case KEY_CTRL_F6: keycodebasic = 29; break;
		case KEY_CTRL_MENU: keycodebasic = 48; break;
		default:break;

	}
	return keycodebasic;
}

int IsKeyDownSH4(int keycode)
{
	unsigned short key[8];
	unsigned char keycodebasic = convertKeycode(keycode);
	const unsigned short* keyboardregister = (unsigned short*)0xA44B0000;

	unsigned char row = keycodebasic%10;
	memcpy(key, keyboardregister, sizeof(unsigned short) << 3);
 
	return (0 != (key[row >> 1] & 1 << keycodebasic / 10 - 1 + ((row & 1) << 3)));


}