typedef void (*PCFUNC)();
typedef struct
{
	char *name;
	PCFUNC f;
}CFUNCTION;

extern CFUNCTION CFunction[];
extern const int CfuncSize;

#define DISP_DATA_MAX 7

void mcl_sin		(ObjectStack *,Object *);
void mcl_cos		(ObjectStack *,Object *);
void mcl_tan		(ObjectStack *,Object *);
void mcl_atn		(ObjectStack *,Object *);
void mcl_int		(ObjectStack *,Object *);
void mcl_abs		(ObjectStack *,Object *);
void mcl_eval		(ObjectStack *,Object *);
void mcl_rand		(ObjectStack *,Object *);

void mcl_val		(ObjectStack *,Object *);
void mcl_tos		(ObjectStack *,Object *);
void mcl_chr		(ObjectStack *,Object *);
void mcl_asc		(ObjectStack *,Object *);
void mcl_mid		(ObjectStack *,Object *);
void mcl_len		(ObjectStack *,Object *);
void mcl_type		(ObjectStack *,Object *);
void mcl_upper		(ObjectStack *,Object *);
void mcl_lower		(ObjectStack *,Object *);

void mcl_print		(ObjectStack *,Object *);
void mcl_printrev	(ObjectStack *,Object *);
void mcl_printxy	(ObjectStack *,Object *);
void mcl_printmini	(ObjectStack *,Object *);
void mcl_printnum	(ObjectStack *,Object *);
void mcl_printnumxy	(ObjectStack *,Object *);
void mcl_printnummini(ObjectStack *,Object *);
void mcl_gets		(ObjectStack *,Object *);
void mcl_getkey		(ObjectStack *,Object *);
void mcl_iskeydown	(ObjectStack *,Object *);
void mcl_locate		(ObjectStack *,Object *);

void mcl_line		(ObjectStack *,Object *);
void mcl_box		(ObjectStack *,Object *);
void mcl_circle		(ObjectStack *,Object *);
void mcl_allclr		(ObjectStack *,Object *);
void mcl_areaclr	(ObjectStack *,Object *);
void mcl_lineclr	(ObjectStack *,Object *);
void mcl_arearev	(ObjectStack *,Object *);
void mcl_setpoint	(ObjectStack *,Object *);
void mcl_getpoint	(ObjectStack *,Object *);
void mcl_putdisp	(ObjectStack *,Object *);
void mcl_savedisp	(ObjectStack *,Object *);
void mcl_rcldisp	(ObjectStack *,Object *);
void mcl_rclpict	(ObjectStack *,Object *);
void mcl_popupwin 	(ObjectStack *,Object *);

void mcl_push		(ObjectStack *,Object *);
void mcl_delete		(ObjectStack *,Object *);
void mcl_clear		(ObjectStack *,Object *);
void mcl_sizeof		(ObjectStack *,Object *);
void mcl_showap		(ObjectStack *,Object *);

void mcl_rtcreset	(ObjectStack *,Object *);
void mcl_setyear	(ObjectStack *,Object *);
void mcl_setmonth	(ObjectStack *,Object *);
void mcl_setdomonth	(ObjectStack *,Object *);
void mcl_setdoweek	(ObjectStack *,Object *);
void mcl_sethour	(ObjectStack *,Object *);
void mcl_setminute	(ObjectStack *,Object *);
void mcl_setsecond	(ObjectStack *,Object *);
void mcl_readyear	(ObjectStack *,Object *);
void mcl_readmonth	(ObjectStack *,Object *);
void mcl_readdomonth(ObjectStack *,Object *);
void mcl_readdoweek	(ObjectStack *,Object *);
void mcl_readhour	(ObjectStack *,Object *);
void mcl_readminute	(ObjectStack *,Object *);
void mcl_readsecond	(ObjectStack *,Object *);

void mcl_exit		(ObjectStack *,Object *);
void mcl_sleep		(ObjectStack *,Object *);
//void mcl_cpuspeed	(ObjectStack *,Object *);
void mcl_waitkey	(ObjectStack *,Object *);


int funcmp( const void *p1, const void *p2 );
